function varargout = lira(varargin)
% LIRA MATLAB code for lira.fig
%      LIRA, by itself, creates a new LIRA or raises the existing
%      singleton*.
%
%      H = LIRA returns the handle to a new LIRA or the handle to
%      the existing singleton*.
%
%      LIRA('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LIRA.M with the given input arguments.
%
%      LIRA('Property','Value',...) creates a new LIRA or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before lira_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to lira_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help lira

% Last Modified by GUIDE v2.5 23-May-2021 21:25:45

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @lira_OpeningFcn, ...
                   'gui_OutputFcn',  @lira_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before lira is made visible.
function lira_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to lira (see VARARGIN)

% Choose default command line output for lira
handles.output = hObject;

addpath('utils')

handles.isAnalysed = false;
handles = createScenario(handles);

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes lira wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = lira_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on slider movement.
function slider_time_Callback(hObject, eventdata, handles)
% hObject    handle to slider_time (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
set(handles.edit_time, 'String', ...
    get(handles.slider_time, 'Value'));
handles = plotMap(handles);
handles = plotAGC(handles);
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function slider_time_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_time (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in push_add_wp.
function push_add_wp_Callback(hObject, eventdata, handles)
% hObject    handle to push_add_wp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
prompt = {'Latitude:','Longitude:', 'Altitude:'};
dlgtitle = 'Add waypoint';
dims = [1 35];
answer = inputdlg(prompt,dlgtitle,dims);
wpArr = [str2double(answer{1})  str2double(answer{2}) ...
    str2double(answer{3})];
handles = getWaypoints(handles);
handles.waypoints = [handles.waypoints; wpArr];
handles = listWaypoints(handles.waypoints, handles);
handles = createScenario(handles);
guidata(hObject, handles);


% --- Executes on button press in push_edit_wp.
function push_edit_wp_Callback(hObject, eventdata, handles)
% hObject    handle to push_edit_wp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
slctIdx = get(handles.listbox_waypoints, 'value');
selectedWP = handles.waypoints(slctIdx,:);
prompt = {'Latitude:','Longitude:', 'Altitude:'};
dlgtitle = 'Edit waypoint';
dims = [1 35];
definput = {num2str(selectedWP(1), 8),num2str(selectedWP(2), 8), ...
    num2str(selectedWP(3), 8)};
answer = inputdlg(prompt,dlgtitle,dims,definput);
wpArr = [str2double(answer{1})  str2double(answer{2}) ...
    str2double(answer{3})];
handles = getWaypoints(handles);
handles.waypoints = [handles.waypoints(1:slctIdx-1,:); wpArr; handles.waypoints(slctIdx+1:end,:)];
handles = listWaypoints(handles.waypoints, handles);
handles = createScenario(handles);
guidata(hObject, handles);

% --- Executes on button press in push_remove_wp.
function push_remove_wp_Callback(hObject, eventdata, handles)
% hObject    handle to push_remove_wp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
slctIdx = get(handles.listbox_waypoints, 'value');
set(handles.listbox_waypoints, 'value',1);
handles = getWaypoints(handles);
handles.waypoints = [handles.waypoints(1:slctIdx-1,:); handles.waypoints(slctIdx+1:end,:)];
handles = listWaypoints(handles.waypoints, handles);
handles = createScenario(handles);
guidata(hObject, handles);



function edit_airspeed_Callback(hObject, eventdata, handles)
% hObject    handle to edit_airspeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_airspeed as text
%        str2double(get(hObject,'String')) returns contents of edit_airspeed as a double
handles = createScenario(handles);
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit_airspeed_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_airspeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in push_analyse.
function push_analyse_Callback(hObject, eventdata, handles)
% hObject    handle to push_analyse (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = detectInterf(handles);
guidata(hObject, handles)



% --- Executes on selection change in listbox_waypoints.
function listbox_waypoints_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_waypoints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox_waypoints contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_waypoints


% --- Executes during object creation, after setting all properties.
function listbox_waypoints_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_waypoints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_lon_Callback(hObject, eventdata, handles)
% hObject    handle to edit_lon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_lon as text
%        str2double(get(hObject,'String')) returns contents of edit_lon as a double
handles = createScenario(handles);
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit_lon_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_lon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_lat_Callback(hObject, eventdata, handles)
% hObject    handle to edit_lat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_lat as text
%        str2double(get(hObject,'String')) returns contents of edit_lat as a double
handles = createScenario(handles);
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit_lat_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_lat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in push_load.
function push_load_Callback(hObject, eventdata, handles)
% hObject    handle to push_load (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
uiopen('testsets/*.mat');
if ~isnan(jammer_pos(1))
    set(handles.edit_lat, 'String', jammer_pos(1))
else
    set(handles.edit_lat, 'String', '')
end
if ~isnan(jammer_pos(2))
    set(handles.edit_lon, 'String', jammer_pos(2))
else
    set(handles.edit_lon, 'String', '')
end
if ~isnan(jammer_pos(3))
    set(handles.edit_alt, 'String', jammer_pos(3))
else
    set(handles.edit_alt, 'String', '')
end
if ~isnan(jammer_start)
    set(handles.edit_start_jam, 'String', jammer_start)
else
    set(handles.edit_start_jam, 'String', '')
end
if ~isnan(jammer_end)
    set(handles.edit_end_jam, 'String', jammer_end)
else
    set(handles.edit_end_jam, 'String', '')
end
if ~isnan(airspeed)
    set(handles.edit_airspeed, 'String', airspeed)
else
    set(handles.edit_airspeed, 'String', '')
end
handles = listWaypoints(waypoints, handles);
handles = createScenario(handles);
guidata(hObject, handles);

% --- Executes on button press in push_save.
function push_save_Callback(hObject, eventdata, handles)
% hObject    handle to push_save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
filename = ['testsets/lira_scenario_' datestr(now,'yymmdd_HHMMSS') '.mat'];
[file, path] = uiputfile(filename);
handles = getWaypoints(handles);
waypoints = handles.waypoints;
airspeed = str2double(get(handles.edit_airspeed, 'String'));
jammer_lat = str2double(get(handles.edit_lat, 'String'));
jammer_lon = str2double(get(handles.edit_lon, 'String'));
jammer_alt = str2double(get(handles.edit_alt, 'String'));
jammer_pos = [jammer_lat jammer_lon jammer_alt];
jammer_start = str2double(get(handles.edit_start_jam, 'String'));
jammer_end = str2double(get(handles.edit_end_jam, 'String'));
save([path '/' file], 'waypoints', 'airspeed', ...
    'jammer_pos', 'jammer_start', 'jammer_end')
guidata(hObject, handles);

function edit_time_Callback(hObject, eventdata, handles)
% hObject    handle to edit_time (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_time as text
%        str2double(get(hObject,'String')) returns contents of edit_time as a double
set(handles.slider_time, 'Value', ...
    str2double(get(handles.edit_time, 'String')));
handles = plotMap(handles);
handles = plotAGC(handles);
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_time_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_time (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_alt_Callback(hObject, eventdata, handles)
% hObject    handle to edit_alt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_alt as text
%        str2double(get(hObject,'String')) returns contents of edit_alt as a double
handles = createScenario(handles);
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit_alt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_alt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_start_jam_Callback(hObject, eventdata, handles)
% hObject    handle to edit_start_jam (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_start_jam as text
%        str2double(get(hObject,'String')) returns contents of edit_start_jam as a double
handles = createScenario(handles);
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit_start_jam_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_start_jam (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_end_jam_Callback(hObject, eventdata, handles)
% hObject    handle to edit_end_jam (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_end_jam as text
%        str2double(get(hObject,'String')) returns contents of edit_end_jam as a double
handles = createScenario(handles);
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit_end_jam_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_end_jam (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in push_stats.
function push_stats_Callback(hObject, eventdata, handles)
% hObject    handle to push_stats (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = getErrorStatistics(handles);
guidata(hObject,handles);

