% Generates the scenario
function handles = createScenario(handles)
    wait = waitbar(0, 'Getting scenario...');
    handles = getWaypoints(handles);
    
    %Remove any previous results
    handles.isAnalysed = false;
    handles.lats = [];
    handles.lons = [];
    cla(handles.axes_map)
    cla(handles.axes_agc)
    set(handles.push_stats, 'Enable', 'off')
    set(handles.edit_time, 'String', '0');
    set(handles.slider_time, 'Value', 0)
    set(handles.text_out_lat, 'String', 'Lat: ')
    set(handles.text_out_lon, 'String', 'Lon: ')
    set(handles.text_out_err, 'String', 'Error: ')
    
    
    % --------- TO BE DELETED  -------
    %handles.waypoints = [0 0 500; 
    %             2000 500 500;
    %             1500 1000 500;
    %             0 500 500];
    %handles.waypoints = [41.40101006815778, 2.176645660762949, 56;
    %              41.40865896168219, 2.186961474392135, 56;
    %              41.420470511237525, 2.1869185590197304, 86;
    %              41.40701740476528, 2.168550791071723, 86];  
        % --------- TO BE DELETED  -------
    if (size(handles.waypoints,1) >= 2)
        set(handles.push_analyse, 'Enable', 'off')
        airspeed = str2double(get(handles.edit_airspeed, 'String'));
        time = cumsum(timeUtils.getArrayTime( ...
            handles.waypoints, airspeed));
        set(handles.slider_time, 'Max', time(end));
        set(handles.slider_time, 'Min', 0);
        set(handles.edit_time, 'String', 0);
        handles = plotMap(handles);
        waitbar(0.5, wait, 'Getting power...');
        handles = getAGC(handles);
        handles = plotAGC(handles);
        set(handles.push_analyse, 'Enable', 'on')
    else
        set(handles.push_analyse, 'Enable', 'off')
    end
    close(wait)
