%Plot map 
function handles = plotMap(handles)
    axes(handles.axes_map);
    jammer_lat = str2double(get(handles.edit_lat, 'String'));
    jammer_lon = str2double(get(handles.edit_lon, 'String'));
    jammer_alt = str2double(get(handles.edit_alt, 'String'));
    jammer_pos = [jammer_lat jammer_lon jammer_alt];
    jammer_start = str2double(get(handles.edit_start_jam, 'String'));
    jammer_end = str2double(get(handles.edit_end_jam, 'String'));
    s = str2double(get(handles.edit_time, 'String'));
    if s < jammer_end && s >= jammer_start
        lineStyle = 'ro';
        mfc = 'red';
    else
        lineStyle = 'bo';
        mfc = 'blue';
    end
    
    plot(handles.waypoints(:,2),handles.waypoints(:,1))
    
    hold on
    if handles.isAnalysed
        set(handles.push_stats, 'Enable', 'on')
        plot(handles.lons,handles.lats,'rx', ...
            'MarkerSize', 2);
        plot(mean(handles.lons),mean(handles.lats),'kp', ...
        'MarkerSize', 12, 'MarkerFaceColor', 'green');
    else
        set(handles.push_stats, 'Enable', 'off')
    end
    plot(handles.waypoints(:,2),handles.waypoints(:,1),'kd', ...
        'MarkerSize', 10, 'MarkerFaceColor', 'black')
    plot(jammer_pos(2),jammer_pos(1), 'k^', 'MarkerSize', 10, ...
        'LineWidth', 3, 'MarkerFaceColor', 'red')
    posinS = positionUtils.getPositionAtS(handles.waypoints, ...
        str2double(get(handles.edit_airspeed, 'String')), ...
        s);
    plot(posinS(2),posinS(1), lineStyle, 'MarkerSize', 10, ...
        'MarkerFaceColor', mfc)
    hold off