classdef speedUtils
    methods(Static)
        
        % Get absolute speed to array of velocities
        function arraySpeed = getArraySpeed(waypoints, nominalSpeed)
            %d = sqrt(sum(diff(waypoints).^2,2));
            d = positionUtils.haversine3Darray(waypoints);
            arraySpeed = diff(waypoints)./d ...
                * speedUtils.knotsToMs(nominalSpeed);
        end
        
        % Convert knots to km/h
        function vinKmh = knotsToKmh(vinKnots)
            vinKmh = 1.852 * vinKnots;
        end
        
        % Convert knots to m/s
        function vinMs = knotsToMs(vinKnots)
            vinMs = 1.852 * vinKnots / 3.6;
        end
        
        % Convert km/h to m/s
        function vinMs = kmhToMs(vinKmh)
            vinMs = vinKmh / 3.6;
        end
        
        % Convert km/h to knots
        function vinKnots = kmhToKnots(vinKmh)
            vinKnots = vinKmh / 1.852;
        end
        
        % Convert m/s to km/h
        function vinKmh = msToKmh(vinMs)
            vinKmh = vinMs * 3.6;
        end
        
        % Convert m/s to knots
        function vinKnots = msToKnots(vinMs)
            vinKnots = 3.6 * vinMs / 1.852;
        end
        
    end
end